src/oc-id/config/routes.rb
OcId::Application.routes.draw do
  root 'home#index'
  get 'id', to: 'home#index'

  scope :id do
    use_doorkeeper

    get 'signin', to: 'sessions#new'
    delete 'signout', to: 'sessions#destroy'

    post '/auth/chef/callback', to: 'sessions#create'
    get '/auth/failure', to: 'sessions#retry'

    resources :sessions, only: [:new, :create, :destroy]
    resource :password_reset, path: '/password-reset', except: [:destroy, :edit]

    resource :profile, only: [:show, :update] do
      put  "password" => "profiles#change_password"
      get  "email" => "profiles#change_email"
      post "regen_key"
    end

    resource :zendesk, only: [:show] do
      get 'signout', to: 'zendesks#signout'
    end

    namespace :v1 do
      resources :users, only: :show

      get 'me', to: 'users#me'
      get 'me/organizations', to: 'users#organizations'
      get 'status', to: 'health#show'
    end
  end
end

src/oc-id/app/controllers/password_resets_controller.rb
class PasswordResetsController < ApplicationController
  def new
  end

  def create
    if params[:username].blank?
      flash.now[:alert] = I18n.t("errors.password_resets.username_blank")
      render 'new', status: :unprocessable_entity
      return
    end

    begin
      user = User.find(escaped_username)

      if user.nil?
        user_not_found
      else
        PasswordResetMailer.password_reset(user).deliver_now
        flash.now[:notice] = I18n.t("errors.password_resets.completion")
        @status = :ok
      end
    rescue Net::HTTPServerException => e
      if e.response.code.to_i == 404
        user_not_found
      elsif e.response.code.to_i == 406
        flash.now[:alert] = I18n.t("errors.password_resets.invalid_username", :name => params[:username])
        @status = :forbidden
      else
        raise
      end
    end

    render 'new', status: @status
  end

  def show
    unless valid_signature?
      flash[:alert] = I18n.t("errors.password_resets.invalid_signature")
      redirect_to action: 'new'
    end
  end

  def update
    if params[:password].blank?
      flash.now[:alert] = I18n.t("errors.passwords.blank", :label => 'Password')
      render 'show', status: :forbidden
    elsif !valid_signature?
      flash.now[:alert] = I18n.t("errors.password_resets.invalid_signature")
      render 'show', status: :forbidden
    else
      begin
        # User should not be able to use a password reset link generated for an
        # old email address after the user has legitimately changed their
        # primary email. The email provided in the request can be trusted because
        # it's already verified when we examine the signature.
        user = User.find(escaped_username)
        if user.email != params[:email]
          flash.now[:alert] = I18n.t("errors.password_resets.invalid_signature")
          render 'show', status: :forbidden
        else
          user.update_attributes('password' => params[:password])
          session[:username] = user.username
          redirect_to signin_path
        end
      rescue Net::HTTPServerException => e
        if e.response.code.to_i == 404
          flash[:notice] = I18n.t("errors.password_resets.completion")
          redirect_to action: 'new'
        elsif e.response.code.to_i == 400
          flash.now[:alert] = error_from_json(e)['error']
          render 'show', status: e.response.code
        else
          raise
        end
      end
    end
  end

  private

  def user_not_found
    flash.now[:notice] = I18n.t("errors.password_resets.completion")
  end

  def escaped_username
    URI.escape(params[:username])
  end

  def valid_signature?
    [:signature, :username, :email, :expires].all? { |p| params[p].present? } &&
    Signature.new(
      params[:username],
      params[:email],
      params[:expires],
      Settings.secret_key_base
    ).valid_for?(params[:signature])
  end
end

src/oc-id/app/views/password_resets/new.html.erb
<div class="column">
  <div>
    <h1>Forgot Your Password?</h1>
  </div>
  <div>
    <p><%= t(".form_caption") %></p>
    <%= form_tag({ action: 'create' }) do -%>
      <div class="row">
        <div class="medium-6 columns username-field">
          <%= text_field_tag :username, nil, required: true, autocomplete: 'off', placeholder: 'Username or email', class: 'radius' %>
        </div>
      </div>
      <div class="row">
        <div class="medium-6 columns">
          <%= button_tag 'Submit', class: 'button' %>
        </div>
      </div>
    <% end -%>
  </div>
</div>

src/oc-id/app/views/password_resets/show.html.erb
<div class="column">
  <div>
    <h1>Reset Your Password</h1>
  </div>
  <%= form_tag(password_reset_path, { method: 'put' }) do -%>
    <div class="row">
      <div class="medium-6 columns password-field">
        <%= password_field_tag :password, nil, required: true, placeholder: 'Password', autocomplete: 'off', class: 'radius' %>
      </div>
    </div>
    <div class="row">
      <div class="medium-6 columns">
        <%= button_tag 'Change Password', class: 'button' %>
      </div>
    </div>
    <%= hidden_field_tag :expires, params[:expires] %>
    <%= hidden_field_tag :signature, params[:signature] %>
    <%= hidden_field_tag :username, params[:username] %>
    <%= hidden_field_tag :email, params[:email] %>
  <% end -%>
</div>